extern struct Hjava_lang_Class *NET_shudo_moba_reflect_MetaClass_classBySignature(struct HNET_shudo_moba_reflect_MetaClass *_this, struct Hjava_lang_String *sigStr, struct Hjava_lang_ClassLoader *loader) {
  ExecEnv *ee = EE();
  char *sig = makeCString(sigStr);
  ClassClass *cb;

  /* Lclass_name;  class_name  */
  if (sig[0] == SIGNATURE_CLASS /* 'L' */) {
    char *ptr = ++sig;
    while ((*ptr != SIGNATURE_ENDCLASS /* `;' */) && (*ptr != '\0'))  ptr++;
    *ptr = '\0';
  }

  if ((sig[0] != SIGNATURE_ARRAY) && loader)
    cb = ClassLoaderFindClass(ee, loader, sig, TRUE);
  else
    cb = FindClass(ee, sig, TRUE);

  if (!cb) {
    if (!exceptionOccurred(ee))
      SignalError(0, "java.lang.ClassNotFoundException", sig);
    return 0;
  }
  return cbHandle(cb);
}


/* following code is derived from
	javasrc/src/share/java/lang/ObjectInputStream.c */
struct methodblock *find_own_rw_obj(
	JNIEnv *env
	ExecEnv *ee, ClassClass *cb, int flag_write) {
  static unsigned long readNameAndTypeId = 0;
  static unsigned long writeNameAndTypeId = 0;

  struct methodblock *methods = cbMethods(cb);
  int methodCount = -1;
  unsigned long id = 0;
  int i;

  if(readNameAndTypeId == 0)
    readNameAndTypeId =
		NameAndTypeToHash(OWN_READOBJ, OWN_READOBJ_SIGNATURE);
  if(writeNameAndTypeId == 0)
    writeNameAndTypeId =
		NameAndTypeToHash(OWN_WRITEOBJ, OWN_WRITEOBJ_SIGNATURE);

  id = (flag_write ? writeNameAndTypeId : readNameAndTypeId);
  methodCount = cbMethodsCount(cb);
  for (i = methodCount - 1; i >= 0; i--) {
    if ((methods[i].fb.access & ACC_PRIVATE) &&		/* private */
	!(methods[i].fb.access & ACC_STATIC) &&		/* isn't static */
	(methods[i].fb.ID == id))
      return &methods[i];
  }

  return NULL;
}
