/*
 * Copyright (C) 1996,1997,1998,2003
 *	Kazuyuki Shudo
 *
 * Permission to use, copy, modify and distribute this software
 * and its documentation for non-commercial purposes and without
 * fee is hereby granted provided this copyright notice.
 *
 * $Id$
 */

package NET.shudo.moba.place;


import java.net.Socket;
import java.net.ServerSocket;
import NET.shudo.moba.net.AccCtrldServSocket;
import java.io.IOException;
import NET.shudo.moba.lang.PlaceAddress;


/**
 * ³׵˱ƥޥɥưǡ<BR>
 * CommandShell ư롣<BR>
 * MobaPlace 鵯ư롣
 *
 * @see NET.shudo.moba.place.CommandShell
 * @see NET.shudo.moba.place.Command
 * @see NET.shudo.moba.place.MobaPlace
 */
public
class CommandServer implements Runnable {
  private int port;
  private boolean debug;

  public CommandServer(int port, boolean debug) {
    this.port = port + PlaceAddress.COMMAND_PORT_DIFF;
    this.debug = debug;
  }

  public void run() {
    ServerSocket servsock = null;

    int shellCount = 0;

    // ³륽åȤ
    try {
      servsock = new AccCtrldServSocket(MobaPlace.accessController, port);
    }
    catch (IOException e) { e.printStackTrace();  System.exit(1); }


    // main loop
    while (true) {
      // accept
      Socket sock = null;

      try {
	sock = servsock.accept();
      }
      catch (IOException e) {
	if (debug)  e.printStackTrace();

	// busy loop 򤱤뤿ǰΤ
	try {  Thread.sleep(5000);  }
	catch (InterruptedException ie) {}

	continue;
      }
      if (debug) {
	System.out.println("CommandServer#run(): accepted.");
	System.out.flush();
      }


      shellCount++;

      Runnable commandShell = null;
      try {
	commandShell = new CommandShell(sock, debug);
      }
      catch (IOException e) {
	commandShell = null;
	if (debug)  e.printStackTrace();
	continue;
      }
      Thread t = new Thread(commandShell, "Command Shell " + shellCount);
      t.setDaemon(false);	// user thread
      t.start();
    }	// while (true);
  }
}
